//
//  SGMimiMailer.h
//  SGMimiMailer
//
//  Created by Justin Williams on 1/17/10.
//  Copyright 2012 Second Gear. All rights reserved.
//

#import <Foundation/Foundation.h>

#ifndef SG_RETAIN
    #if __has_feature(objc_arc)
        #define SG_RETAIN(x) x
        #define SG_RELEASE(x)
        #define SG_AUTORELEASE(x) x
        #define SG_SUPER_DEALLOC
    #else
        #define __SG_WEAK
        #define SG_WEAK assign
        #define SG_RETAIN(x) [x retain]
        #define SG_RELEASE(x) [x release]
        #define SG_AUTORELEASE(x) [x autorelease]
        #define SG_SUPER_DEALLOC [super dealloc]
    #endif
#endif

//  Weak reference support
#ifndef SG_WEAK
    #if defined __IPHONE_OS_VERSION_MIN_REQUIRED
        #if __IPHONE_OS_VERSION_MIN_REQUIRED > __IPHONE_4_3
            #define __SG_WEAK __weak
            #define SG_WEAK weak
        #else
            #define __SG_WEAK __unsafe_unretained
            #define SG_WEAK unsafe_unretained
        #endif
    #elif defined __MAC_OS_X_VERSION_MIN_REQUIRED
        #if __MAC_OS_X_VERSION_MIN_REQUIRED > __MAC_10_6
            #define __SG_WEAK __weak
            #define SG_WEAK weak
        #else
            #define __SG_WEAK __unsafe_unretained
            #define SG_WEAK unsafe_unretained
        #endif
    #endif
#endif

@protocol SGMimiMailerDelegate;

@interface SGMimiMailer : NSObject 

@property (nonatomic, SG_WEAK) id <SGMimiMailerDelegate> delegate;

- (id)initWithUserName:(NSString *)userName key:(NSString *)apiKey delegate:(id <SGMimiMailerDelegate>)delegate;
- (BOOL)addEmailAddress:(NSString *)address toList:(NSString *)list error:(NSError **)error;
@end

@protocol SGMimiMailerDelegate <NSObject>
- (void)requestSucceeded;
- (void)requestFailedWithError:(NSError *)error;
@end
